using System;
using System.Security.Cryptography;
using System.IO;

// generates a random <machineKey> element that you can use
// to replace the existing one in your machine.config file
// in order to synchronize the ASP.NET encryption and
// validation keys in your web farm
class GenerateMachineKey {

    static RNGCryptoServiceProvider s_rng = new RNGCryptoServiceProvider();

    // 64 bytes is max size supported by ASP.NET
    const int _validationKeyLength = 64;

    // 24 bytes is max size supported by ASP.NET (3DES)
    const int _decryptionKeyLength = 24;

    static void Main(string[] args) {
        Console.Write("<machineKey validationKey='");

        _writeKeyAsHexDigits(_getRandom(_validationKeyLength));

        Console.WriteLine("'");
        Console.Write("            decryptionKey='");

        _writeKeyAsHexDigits(_getRandom(_decryptionKeyLength));

        Console.WriteLine("'");
        Console.Write("               validation='SHA1'/>");
    }
    static byte[] _getRandom(int cb) {
        byte[] randomData = new byte[cb];
        s_rng.GetBytes(randomData);
        return randomData;
    }
    static void _writeKeyAsHexDigits(byte[] key) {
        for (int i = 0; i < key.Length; ++i) {
            Console.Write("{0:X2}", key[i]);
        }
    }
}
